<template>
  <v-container fluid>
    <h1>Vuex can do everything</h1>

    <my-table-wrapper :items="users"/>

    <v-card class="mt-2">
      <v-card-actions>
        <v-btn flat @click="clearComponentState">Clear</v-btn>
        <v-spacer/>
        <v-btn flat @click="asyncActionToUsers">Async action</v-btn>
        <v-btn flat @click="asyncCommitToUsers">Async commit</v-btn>
        <v-btn flat @click="asyncActionWithCommit">Optimizin' namespaces</v-btn>
        <v-btn flat @click="asyncCommitWithAction">From mutation to action to store</v-btn>
      </v-card-actions>
    </v-card>
  </v-container>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import { MEGA_MUTATE_ASYNC_RETURN_USERS, MEGA_MUTATE_ACTION_RETURN_USERS } from '../store/mutationTypes'
import MyTableWrapper from '../components/myTableWrapper'

export default {
  name: 'MegaVuex',
  components: { MyTableWrapper },
  data () {
    return {
      users: []
    }
  },

  computed: {
    ...mapGetters('megaVuex', ['getUsers'])
  },

  methods: {
    ...mapActions('megaVuex', ['actionWhichReturnResponse', 'actionWhichReturnAsyncCommit']),
    populateUsers (users) {
      this.users = users
    },
    clearComponentState () {
      this.users = []
    },
    async asyncActionToUsers () {
      const users = await this.actionWhichReturnResponse()
      this.populateUsers(users)
    },
    asyncCommitToUsers () {
      this.$store.commit(`megaVuex/${MEGA_MUTATE_ASYNC_RETURN_USERS}`, this.populateUsers)
    },
    async asyncActionWithCommit () {
      // NO NAMESPACE NEEDED
      const commit = await this.actionWhichReturnAsyncCommit()
      commit(MEGA_MUTATE_ASYNC_RETURN_USERS, this.populateUsers)
    },
    asyncCommitWithAction () {
      this.$store.commit(`megaVuex/${MEGA_MUTATE_ACTION_RETURN_USERS}`, this.populateUsers)
    }
  },
  created () {
    this.asyncActionToUsers()
  }
}
</script>
